-- -------------------------------------------------------------------------- --
-- ManaTracker By Xulos ( EU ALLIANCE YSONDRE )      
-- -------------------------------------------------------------------------- --

UIPanelWindows["ManaTrackerFrame"] = { area = "doublewide", pushable = 0, width = 200, xoffset = 80, whileDead = 1 };

ManaTracker = {};
ManaTracker.version = GetAddOnMetadata("ManaTracker", "Version");

-- L
local L = setmetatable({}, {
    __index = function(t, k)
		return k;
    end
});
if (GetLocale() == "frFR") then
	L["Track Current Energy"] = "Traquer l'energie actuelle";
	L["Track Mana"]="Traquer la Mana";
	L["Track Health"]="Traquer la Vie";
end
-- static
-- Mean
local GainMeanArray = {};
local LossMeanArray = {};
function InitMean(arr, c) -- array, nombre de valeurs
    arr.c = c; -- count
    for i=1,c do
        arr[i] = 0;
    end
    arr.s = 0; -- sum
    arr.cc = 0; -- current count
end
function PushAndMean(arr, v)
    if (arr.c == 0 ) then
        error("meanInit not call");
    else
        if (arr.cc < arr.c ) then
            arr.cc = arr.cc + 1;
        end
        
        arr.s = 0;
        for i=arr.cc,1,-1 do
            arr[i] = arr[i-1];
            if (arr[i] ) then arr.s = arr.s + arr[i]; end
        end
        arr[1] = v;
        arr.s = arr.s + v;

        return arr.s/arr.cc, arr.s, arr.cc;
    end
end
function ManaTrackerFrame_Init(self)
	ManaTrackerDB = ManaTrackerDB or {};
	ManaTrackerDB.Params = ManaTrackerDB.Params or {};
	ManaTrackerDB.Params.Width = 300;
	ManaTrackerDB.Params.Showed = ManaTrackerDB.Params.Showed or false;
	ManaTrackerDB.Params.SeuilLikeInfiniteInSeconds = 120;
			
	ManaTracker.AddonPrefix = "ManaTracker";
	--RegisterAddonMessagePrefix(ManaTracker.AddonPrefix);
	
	local localizedClass = "";
	localizedClass, ManaTracker.MyClass = UnitClass("player");
	
	ManaTrackerDB.PartyLst = {};
	
	ManaTrackerDB.Players = {};
	
	ManaTracker.MyName = UnitName("player");
	
	ManaTrackerDB.MeanCountMana = ManaTrackerDB.MeanCountMana or 15;
	ManaTrackerDB.MeanCountHealth = ManaTrackerDB.MeanCountHealth or 30;

	ManaTrackerDB.TrackingMode = ManaTrackerDB.TrackingMode or "TCE"; -- TCE / TM / TH => Track Current Energy / Track Mana / Track Health

	ManaTracker_SwitchMeanCount();
	
	if ( ManaTrackerDB.Params.Showed == true ) then ManaTrackerFrame:Show(); end
end
function ManaTracker_SwitchMeanCount()
	local cE;
	if ( ManaTrackerDB.TrackingMode == "TM" or ManaTrackerDB.TrackingMode == "TCE" ) then
		cE = ManaTrackerDB.MeanCountMana;
	else
		cE = ManaTrackerDB.MeanCountHealth;
	end
	InitMean(GainMeanArray, cE);
	InitMean(LossMeanArray, cE);
end
function ManaTrackerMinimapButton_OnClick(self, button)
    if (ManaTrackerFrame) then
		if ( button == "LeftButton" ) then
			if(ManaTrackerFrame:IsVisible() ) then
				ManaTrackerFrame:Hide();
				ManaTrackerDB.Params.Showed = false;
			else
				ManaTrackerFrame:Show();
				ManaTrackerDB.Params.Showed = true;
			end
		elseif ( button == "RightButton" ) then
			ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, ManaTrackerMinimapButton, 15, 0);
		end
    end
end
function ManaTrackerMinimapButton_OnLoad(self)
	ManaTrackerMinimapButton.label:SetText("MaT");
end
function ManaTrackerMinimapButton_OnEnter(self)
	GameTooltip:SetOwner(self);
	GameTooltip:SetText("ManaTracker "..ManaTracker.version);
end
function ManaTrackerMinimapButton_OnLeave(self)
	GameTooltip:Hide();
end
function ManaTrackerBar_OnEnter(self)
	
end
function ManaTrackerBar_OnLeave(self)
	GameTooltip:Hide();
end
function ManaTrackerFrame_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	--self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
end
function ManaTrackerFrame_OnEvent(self, event, arg1, arg2, ...)
	if ( event == "VARIABLES_LOADED" ) then
		ManaTrackerFrame_Init(self);
		self:UnregisterEvent("VARIABLES_LOADED");
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		if ( UnitAffectingCombat("player") == false ) then
			ManaTracker:InitFrame();
			DEFAULT_CHAT_FRAME:AddMessage("ManaTracker "..ManaTracker.version.." LOADED");
			self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		else
			DEFAULT_CHAT_FRAME:AddMessage("ManaTracker "..ManaTracker.version.." NOT LOADED");
			DEFAULT_CHAT_FRAME:AddMessage("PLEASE RELOAD INTERFACE AFTER THE END OF YOUR FIGHT");
		end
	elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		ManaTrackerFrame_COMBAT_LOG_EVENT_UNFILTERED(self, ...);
	end
end
local ManaTrackerFrame_onUpdateCounter = 0;
local ManaTrackerFrame_UpdateEachNFrame = 20;
function ManaTrackerFrame_OnUpdate(self, elapsed)
	ManaTrackerFrame_onUpdateCounter = ManaTrackerFrame_onUpdateCounter + 1;
    if ManaTrackerFrame_onUpdateCounter % ManaTrackerFrame_UpdateEachNFrame == 0 then
        ManaTrackerFrame_onUpdateCounter = 0;
        ManaTrackerFrameRefresh();
    end
end 
local currentPower = UnitPower("player");
local currentPowerPerSecMax = 100;
local currentPowerGain = 0;
local currentPowerLoss = 0;
local lastEstimGain, lastEstimLoss;
local currentTime = debugprofilestop();
function ManaTrackerFrameRefresh()
-- maj de la valeurs des barres
	local cPower, cPowerMax;
	if ( ManaTrackerDB.TrackingMode == "TCE" ) then
		cPower = UnitPower("player");
		cPowerMax = UnitPowerMax("player");
	elseif ( ManaTrackerDB.TrackingMode == "TM" ) then
		cPower = UnitPower("player", 0);
		cPowerMax = UnitPowerMax("player", 0);
	elseif ( ManaTrackerDB.TrackingMode == "TH" ) then
		cPower = UnitHealth("player");
		cPowerMax = UnitHealthMax("player");
	end
	
	if ( cPower and cPowerMax ) then
		local cTime = debugprofilestop();

		local gain = 0;
		local loss = 0;
			
		if ( cPower ~= currentPower ) then
			local val = math.floor((cPower-currentPower)/(cTime-currentTime)*1000);
			if ( val > 0 ) then 
				gain = PushAndMean(GainMeanArray,val);
				loss = PushAndMean(LossMeanArray,0);
			elseif ( val < 0 ) then 
				gain = PushAndMean(GainMeanArray,0);
				loss = PushAndMean(LossMeanArray,val*-1);
			end
			currentPower = cPower;
			currentTime = cTime;
		end
		
		if ( gain > currentPowerPerSecMax ) then currentPowerPerSecMax = math.floor(gain); end
		if ( loss > currentPowerPerSecMax ) then currentPowerPerSecMax = math.floor(loss); end
			
		--print(string.format("%.2f",gain/currentPowerPerSecMax).." / "..string.format("%.2f",loss/currentPowerPerSecMax));
		local GainToDisp = math.floor(gain/currentPowerPerSecMax*100);
		local LossToDisp = math.floor(loss/currentPowerPerSecMax*100);
		
		if ( gain == 0 ) then GainPerSecLabel:SetText("   -");
		else GainPerSecLabel:SetText("  "..string.format("%.1f",gain).."u/s");
		end
		
		local estimGain = (cPowerMax-cPower)/gain;
		if ( estimGain == 0 ) then EstimGainLabel:SetText("- ");
		elseif ( gain > 0 ) then EstimGainLabel:SetText(string.format("%.1f",estimGain).."s "); lastEstimGain = estimGain;
		elseif ( lastEstimGain ) then EstimGainLabel:SetText(string.format("%.1f",lastEstimGain).."s ");
		else EstimGainLabel:SetText("- ");
		end
		
		if ( loss == 0 ) then LossPerSecLabel:SetText("-   ");
		else LossPerSecLabel:SetText(string.format("%.1f",loss).."u/s   ");
		end
		
		local estimLoss = cPower/loss;
		if ( estimLoss > ManaTrackerDB.Params.SeuilLikeInfiniteInSeconds or estimLoss == 0 ) then EstimLossLabel:SetText(" -");
		elseif ( loss > 0 ) then EstimLossLabel:SetText(" "..string.format("%.1f",estimLoss).."s"); lastEstimLoss = estimLoss; 
		elseif ( lastEstimLoss ) then EstimLossLabel:SetText(" "..string.format("%.1f",lastEstimLoss).."s");
		else EstimLossLabel:SetText("- ");
		end
		
		ManaGainBar:SetValue(GainToDisp);
		ManaLossBar:SetValue(100-LossToDisp);
		if ( GainToDisp >= LossToDisp ) then
			ManaGainBar2:SetValue(GainToDisp - LossToDisp);
			ManaLossBar2:SetValue(100);
		elseif ( GainToDisp < LossToDisp ) then
			ManaGainBar2:SetValue(0);
			ManaLossBar2:SetValue(100 - (LossToDisp - GainToDisp) );
		end
		
		local PowerToDisp = math.floor(cPower/cPowerMax*100);
		ManaPowerBarLabel:SetText(string.format("%.1f",PowerToDisp).."%");
		ManaPowerBar3:SetValue(PowerToDisp);
		
		if ( cPower == cPowerMax ) then currentPowerPerSecMax = 100; end -- remet a 0 la barre
	end
end  
function ManaTrackerFrame_COMBAT_LOG_EVENT_UNFILTERED(_,DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...)
	ManaTracker:ProfilingUseFuncStart(ManaTrackerDB, "COMBAT_LOG_EVENT_UNFILTERED");
    
	local TargetType, GUID = nil, TargetName, SourceName, SourceType, SourceClass, TargetClass;
	
	local ret = nil;
	
	if ( string.match(EVENTTYPE, "ENERGIZE") ) then
		local spellName = select(2, ...);
		local powerType = select(5, ...);
		local amount = select(4,...);
		print(spellName,powerType, amount);
	end 
	
end
function ManaTracker_AddDropDownItem(...)
  --[[
	List of button attributes
	======================================================
	info.text = [STRING]  --  The text of the button
	info.value = [ANYTHING]  --  The value that UIDROPDOWNMENU_MENU_VALUE is set to when the button is clicked
	info.func = [function()]  --  The function that is called when you click the button
	info.checked = [nil, true, function]  --  Check the button if true or function returns true
	info.isNotRadio = [nil, true]  --  Check the button uses radial image if false check box image if true
	info.isTitle = [nil, true]  --  If it's a title the button is disabled and the font color is set to yellow
	info.disabled = [nil, true]  --  Disable the button and show an invisible button that still traps the mouseover event so menu doesn't time out
	info.tooltipWhileDisabled = [nil, 1] -- Show the tooltip, even when the button is disabled.
	info.hasArrow = [nil, true]  --  Show the expand arrow for multilevel menus
	info.hasColorSwatch = [nil, true]  --  Show color swatch or not, for color selection
	info.r = [1 - 255]  --  Red color value of the color swatch
	info.g = [1 - 255]  --  Green color value of the color swatch
	info.b = [1 - 255]  --  Blue color value of the color swatch
	info.colorCode = [STRING] -- "|cAARRGGBB" embedded hex value of the button text color. Only used when button is enabled
	info.swatchFunc = [function()]  --  Function called by the color picker on color change
	info.hasOpacity = [nil, 1]  --  Show the opacity slider on the colorpicker frame
	info.opacity = [0.0 - 1.0]  --  Percentatge of the opacity, 1.0 is fully shown, 0 is transparent
	info.opacityFunc = [function()]  --  Function called by the opacity slider when you change its value
	info.cancelFunc = [function(previousValues)] -- Function called by the colorpicker when you click the cancel button (it takes the previous values as its argument)
	info.notClickable = [nil, 1]  --  Disable the button and color the font white
	info.notCheckable = [nil, 1]  --  Shrink the size of the buttons and don't display a check box
	info.owner = [Frame]  --  Dropdown frame that "owns" the current dropdownlist
	info.keepShownOnClick = [nil, 1]  --  Don't hide the dropdownlist after a button is clicked
	info.tooltipTitle = [nil, STRING] -- Title of the tooltip shown on mouseover
	info.tooltipText = [nil, STRING] -- Text of the tooltip shown on mouseover
	info.tooltipOnButton = [nil, 1] -- Show the tooltip attached to the button instead of as a Newbie tooltip.
	info.justifyH = [nil, "CENTER"] -- Justify button text
	info.arg1 = [ANYTHING] -- This is the first argument used by info.func
	info.arg2 = [ANYTHING] -- This is the second argument used by info.func
	info.fontObject = [FONT] -- font object replacement for Normal and Highlight
	info.menuTable = [TABLE] -- This contains an array of info tables to be displayed as a child menu
	info.noClickSound = [nil, 1]  --  Set to 1 to suppress the sound when clicking the button. The sound only plays if .func is set.
	info.padding = [nil, NUMBER] -- Number of pixels to pad the text on the right side
	]]
  it = {};
  level, it.text, it.value, it.checked, it.hasArrow, it.func, it.arg1 = ...;
  UIDropDownMenu_AddButton(it, level);
  wipe(it);
end
function ManaTracker_DropDownMenu_Init() -- TARGET MENU
	ManaTracker_DropDownMenu.displayMode = "MENU"
	
	ManaTracker_DropDownMenu.initialize = function(self, level)
		if level == 1 then
			ManaTracker_AddDropDownItem(level, L["Track Current Energy"], nil, (ManaTrackerDB.TrackingMode == "TCE"), nil, ManaTracker_SwitchTracking, "TCE", nil);
			ManaTracker_AddDropDownItem(level, L["Track Mana"], nil, (ManaTrackerDB.TrackingMode == "TM"), nil, ManaTracker_SwitchTracking, "TM", nil);
			ManaTracker_AddDropDownItem(level, L["Track Health"], nil, (ManaTrackerDB.TrackingMode == "TH"), nil, ManaTracker_SwitchTracking, "TH", nil);
		end
	end
end
function ManaTracker_SwitchTracking(mode)
	if ( mode.arg1 == "TCE" or mode.arg1 == "TM" or mode.arg1 == "TH"   ) then
		ManaTrackerDB.TrackingMode = mode.arg1;
		ManaTracker_SwitchMeanCount();
		currentPowerPerSecMax = 100;
	end
end
function ManaTracker:InitFrame() -- ok
	ManaTrackerFrame:SetWidth(ManaTrackerDB.Params.Width);
	ManaTrackerFrame:SetHeight(59);
	local mFrameParentLevel = ManaTrackerFrame:GetFrameLevel();
	
	-- 1er systeme de barres
	local SGBG = CreateFrame("StatusBar", "ManaGainBarBG", ManaTrackerFrame);
	if ( ManaGainBarBG ) then
		SGBG:SetFrameLevel(mFrameParentLevel + 1);
		SGBG:SetWidth(ManaTrackerDB.Params.Width/2);
		SGBG:SetHeight(20);
		SGBG:SetPoint("CENTER",0,15);
		SGBG:SetPoint("RIGHT",0,15);
		SGBG:SetMinMaxValues(0, 100);
		SGBG:SetValue(100);
		SGBG:SetStatusBarTexture("Interface\\Buttons\\UI-Listbox-Highlight2");
		SGBG:SetStatusBarColor(0,0,0,1);
	end
	local S1 = CreateFrame("StatusBar", "ManaGainBar", ManaTrackerFrame);
	if ( ManaGainBar ) then
		S1:SetFrameLevel(mFrameParentLevel + 2);
		S1:SetWidth(ManaTrackerDB.Params.Width/2);
		S1:SetHeight(20);
		S1:SetPoint("CENTER",0,15);
		S1:SetPoint("RIGHT",0,15);
		S1:SetMinMaxValues(0, 100);
		S1:SetValue(0);
		S1:SetStatusBarTexture("Interface\\Buttons\\UI-Listbox-Highlight2");
		S1:SetStatusBarColor(0.1,0.8,0,1);
		
		local fs2 = ManaGainBar:CreateFontString("GainPerSecLabel", "OVERLAY", "GameFontNormal");
		if ( GainPerSecLabel ) then
			fs2:SetPoint("LEFT",0,0);
			fs2:SetText("233u/s");
		end
	end
	local SLBG = CreateFrame("StatusBar", "ManaLossBarBG", ManaTrackerFrame);
	if ( ManaLossBarBG ) then
		SLBG:SetFrameLevel(mFrameParentLevel + 1);
		SLBG:SetWidth(ManaTrackerDB.Params.Width/2);
		SLBG:SetHeight(20);
		SLBG:SetPoint("CENTER",0,15);
		SLBG:SetPoint("LEFT",0,15);
		SLBG:SetMinMaxValues(0, 100);
		SLBG:SetValue(100);
		SLBG:SetStatusBarTexture("Interface\\Buttons\\UI-Listbox-Highlight2");
		SLBG:SetStatusBarColor(0.8,0.1,0,1);
	end
	local S2 = CreateFrame("StatusBar", "ManaLossBar", ManaTrackerFrame);
	if ( ManaLossBar ) then
		S2:SetFrameLevel(mFrameParentLevel + 2);
		S2:SetWidth(ManaTrackerDB.Params.Width/2);
		S2:SetHeight(20);
		S2:SetPoint("CENTER",0,15);
		S2:SetPoint("LEFT",0,15);
		S2:SetMinMaxValues(0, 100);
		S2:SetValue(100);
		S2:SetStatusBarTexture("Interface\\Buttons\\UI-Listbox-Highlight2");
		S2:SetStatusBarColor(0,0,0,1);
		
		local fs2 = ManaLossBar:CreateFontString("LossPerSecLabel", "OVERLAY", "GameFontNormal");
		if ( LossPerSecLabel ) then
			fs2:SetPoint("RIGHT",0,0);
			fs2:SetText("233u/s");
		end
	end
	-- 2eme systeme de barres
	local SGBG2 = CreateFrame("StatusBar", "ManaGainBarBG2", ManaTrackerFrame);
	if ( ManaGainBarBG2 ) then
		SGBG2:SetFrameLevel(mFrameParentLevel + 1);
		SGBG2:SetWidth(ManaTrackerDB.Params.Width/2);
		SGBG2:SetHeight(5);
		SGBG2:SetPoint("CENTER",0,0);
		SGBG2:SetPoint("RIGHT",0,0);
		SGBG2:SetMinMaxValues(0, 100);
		SGBG2:SetValue(100);
		SGBG2:SetStatusBarTexture("Interface\\Buttons\\UI-Listbox-Highlight2");
		SGBG2:SetStatusBarColor(0,0,0,1);
	end
	local S12 = CreateFrame("StatusBar", "ManaGainBar2", ManaTrackerFrame);
	if ( ManaGainBar2 ) then
		S12:SetFrameLevel(mFrameParentLevel + 2);
		S12:SetWidth(ManaTrackerDB.Params.Width/2);
		S12:SetHeight(5);
		S12:SetPoint("CENTER",0,0);
		S12:SetPoint("RIGHT",0,0);
		S12:SetMinMaxValues(0, 100);
		S12:SetValue(0);
		S12:SetStatusBarTexture("Interface\\Buttons\\UI-Listbox-Highlight2");
		S12:SetStatusBarColor(0.1,0.8,0,1);
	end
	local SLBG2 = CreateFrame("StatusBar", "ManaLossBarBG2", ManaTrackerFrame);
	if ( ManaLossBarBG2 ) then
		SLBG2:SetFrameLevel(mFrameParentLevel + 1);
		SLBG2:SetWidth(ManaTrackerDB.Params.Width/2);
		SLBG2:SetHeight(5);
		SLBG2:SetPoint("CENTER",0,0);
		SLBG2:SetPoint("LEFT",0,0);
		SLBG2:SetMinMaxValues(0, 100);
		SLBG2:SetValue(100);
		SLBG2:SetStatusBarTexture("Interface\\Buttons\\UI-Listbox-Highlight2");
		SLBG2:SetStatusBarColor(0.8,0.1,0,1);
	end
	local S22 = CreateFrame("StatusBar", "ManaLossBar2", ManaTrackerFrame);
	if ( ManaLossBar2 ) then
		S22:SetFrameLevel(mFrameParentLevel + 2);
		S22:SetWidth(ManaTrackerDB.Params.Width/2);
		S22:SetHeight(5);
		S22:SetPoint("CENTER",0,0);
		S22:SetPoint("LEFT",0,0);
		S22:SetMinMaxValues(0, 100);
		S22:SetValue(100);
		S22:SetStatusBarTexture("Interface\\Buttons\\UI-Listbox-Highlight2");
		S22:SetStatusBarColor(0,0,0,1);
	end
	-- 3eme systeme de barre
	local SGBG3 = CreateFrame("StatusBar", "ManaPowerBarBG3", ManaTrackerFrame);
	if ( ManaPowerBarBG3 ) then
		SGBG3:SetFrameLevel(mFrameParentLevel + 1);
		SGBG3:SetWidth(ManaTrackerDB.Params.Width);
		SGBG3:SetHeight(20);
		SGBG3:SetPoint("CENTER",ManaTrackerDB.Params.Width/2,-15);
		SGBG3:SetPoint("LEFT",0,-15);
		SGBG3:SetMinMaxValues(0, 100);
		SGBG3:SetValue(100);
		SGBG3:SetStatusBarTexture("Interface\\Buttons\\UI-Listbox-Highlight2");
		SGBG3:SetStatusBarColor(0,0,0,1);
	end
	local S13 = CreateFrame("StatusBar", "ManaPowerBar3", ManaTrackerFrame);
	if ( ManaPowerBar3 ) then
		S13:SetFrameLevel(mFrameParentLevel + 2);
		S13:SetWidth(ManaTrackerDB.Params.Width);
		S13:SetHeight(15);
		S13:SetPoint("CENTER",ManaTrackerDB.Params.Width/2,-15);
		S13:SetPoint("LEFT",0,-15);
		S13:SetMinMaxValues(0, 100);
		S13:SetValue(100);
		S13:SetStatusBarTexture("Interface\\Buttons\\UI-Listbox-Highlight2");
		S13:SetStatusBarColor(0.3,0.3,0.9,1);
		
		local fs1 = ManaPowerBar3:CreateFontString("ManaPowerBarLabel", "OVERLAY", "GameFontNormal");
		if ( ManaPowerBarLabel ) then
			fs1:SetPoint("CENTER",0,0);
			fs1:SetText("-");
		end
		
		local fs2 = ManaPowerBar3:CreateFontString("EstimLossLabel", "OVERLAY", "GameFontNormal");
		if ( EstimLossLabel ) then
			fs2:SetPoint("LEFT",0,0);
			fs2:SetText("-");
		end
		
		local fs3 = ManaPowerBar3:CreateFontString("EstimGainLabel", "OVERLAY", "GameFontNormal");
		if ( EstimGainLabel ) then
			fs3:SetPoint("RIGHT",0,0);
			fs3:SetText("-");
		end
	end
	--
	ManaTracker_DropDownMenu_Init();
	--SGBG:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, SGBG, 0, 0); end);
	--S1:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, S1, 0, 0); end);
	--SLBG:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, SLBG, 0, 0); end);
	--S2:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, S2, 0, 0); end);
	--SGBG2:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, SGBG2, 0, 0); end);
	--S12:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, S12, 0, 0); end);
	--SLBG2:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, SLBG2, 0, 0); end);
	--S22:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, S22, 0, 0); end);
	--SGBG3:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, SGBG3, 0, 0); end);
	--S13:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, S13, 0, 0); end);
	--ManaTrackerMinimapButton:SetScript("OnClick", function() ToggleDropDownMenu(1, nil, ManaTracker_DropDownMenu, ManaTrackerMinimapButton, 0, 0); end);
end
function ManaTracker:ResetBar(GuiBar) -- ok
	if ( GuiBar ) then
	
	end
end
function ManaTracker:UpdateFrame() -- ok
end
function ManaTracker:FormatAmountToPercentValue(val, precision, total)
	if ( val and precision and total ) then
		local percentVal = (val*100)/total;
		return tonumber(string.format("%."..tostring(precision).."f", percentVal));
	else
		return -1;
	end
end
function ManaTracker:GetColorCodeFromRGB(red, green, blue) -- de 0  1 en float
	local codeWow = nil;
	if ( red and green and blue ) then
		local redColor = string.format("%0.2X", math.ceil(string.format("%.2f", red)*255));
		local greenColor = string.format("%0.2X", math.ceil(string.format("%.2f", green)*255));
		local blueColor = string.format("%0.2X", math.ceil(string.format("%.2f", blue)*255));
		codeWow = "|cFA"..tostring(redColor)..tostring(greenColor)..tostring(blueColor);
	end
	return codeWow; 
end
function ManaTracker:GetColorCodeFromRGBStruct(rgbStruct) -- de 0  1 en float
	local codeWow = ManaTracker:GetColorCodeFromRGB(rgbStruct.r, rgbStruct.g, rgbStruct.b);
	return codeWow; 
end
function ManaTracker:UpdateFrame() -- ok
	
end
